%define anolis_release 1
%global _hardened_build 1

Name:          ppp
Version:       2.4.9
Release:       %{anolis_release}%{?dist}
Summary:       The Point-to-Point Protocol daemon
License:       BSD and LGPLv2+ and GPLv2+ and Public Domain
URL:           http://www.samba.org/ppp

Source0:       https://github.com/paulusmack/ppp/archive/ppp-%{version}.tar.gz
Source1:       ppp-pam.conf
Source2:       ppp-logrotate.conf
Source3:       ppp-tmpfiles.conf
Source4:       ip-down
Source5:       ip-down.ipv6to4
Source6:       ip-up
Source7:       ip-up.ipv6to4
Source8:       ipv6-down
Source9:       ipv6-up
Source10:      ifup-ppp
Source11:      ifdown-ppp
Source12:      ppp-watch.tar.xz

Patch0000:     ppp-2.4.9-config.patch
Patch0001:     doc-add-configuration-samples.patch
Patch0002:     ppp-2.4.9-build-sys-don-t-hardcode-LIBDIR-but-set-it-according.patch
Patch0003:     scritps-use-change_resolv_conf-function.patch
Patch0004:     build-sys-don-t-put-connect-errors-log-to-etc-ppp.patch
Patch0005:     ppp-2.4.8-pppd-we-don-t-want-to-accidentally-leak-fds.patch
Patch0006:     ppp-2.4.9-everywhere-O_CLOEXEC-harder.patch
Patch0007:     everywhere-use-SOCK_CLOEXEC-when-creating-socket.patch
Patch0008:     pppd-move-pppd-database-to-var-run-ppp.patch
Patch0009:     rp-pppoe-add-manpage-for-pppoe-discovery.patch
Patch0010:     scritps-fix-ip-up.local-sample.patch
Patch0011:     build-sys-install-rp-pppoe-plugin-files-with-standar.patch
Patch0012:     build-sys-install-pppoatm-plugin-files-with-standard.patch
Patch0013:     ppp-2.4.8-pppd-install-pppd-binary-using-standard-perms-755.patch
Patch0014:     ppp-2.4.9-configure-cflags-allow-commas.patch
# https://github.com/ppp-project/ppp/commit/d7e62a8499c4032d79e05afbd8fd3efd51c5b148
Patch0015:     ppp-2.4.9-pppd-eap-Fix-bug-causing-incorrect-response-length-3.patch
# https://github.com/ppp-project/ppp/commit/e609ed8bb62e4648568eaa49fbbc858dfda6d122
Patch0016:     ppp-2.4.9-pppd-Fix-logical-error-in-comparing-valid-encryption.patch
# https://github.com/ppp-project/ppp/pull/267/commits/6bfe06b9428a60eb637d5450d65dd3932fe5a83f
Patch0017:     ppp-2.4.9-pppd-Expose-the-MPPE-keys-generated-through-an-API-2.patch

BuildRequires: make
BuildRequires: gcc
BuildRequires: pam-devel, libpcap-devel, systemd, systemd-devel, glib2-devel
BuildRequires: openssl-devel

Requires:      glibc >= 2.0.6, /etc/pam.d/system-auth, libpcap >= 14:0.8.3-6, systemd
Requires(pre): /usr/bin/getent
Requires(pre): /usr/sbin/groupadd

%description
The ppp package contains the PPP (Point-to-Point Protocol) daemon and
documentation for PPP support. The PPP protocol provides a method for
transmitting datagrams over serial point-to-point links. PPP is
usually used to dial in to an ISP (Internet Service Provider) or other
organization over a modem and phone line.

%package -n     network-scripts-%{name}
Summary:        PPP legacy network service support
Requires:       network-scripts
Supplements:    (%{name} and network-scripts)

%description -n network-scripts-%{name}
This provides the ifup and ifdown scripts for use with the legacy network
service.

%package        devel
Summary:        Headers for ppp plugin development
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains the header files for building plugins for ppp.

%package        doc
Summary:        Docs package for ppp
Requires:       %{name} = %{version}-%{release}

%description    doc
Docs package for ppp

%prep
%autosetup -n %{name}-%{name}-%{version} -p1

tar -xJf %{SOURCE12}

%build
%configure --cflags="$RPM_OPT_FLAGS -fPIC -Wall -fno-strict-aliasing"
%{make_build} LDFLAGS="%{?build_ldflags} -pie"
%{make_build} -C ppp-watch LDFLAGS="%{?build_ldflags} -pie"

%install
make INSTROOT=%{buildroot} install install-etcppp
find scripts -type f | xargs chmod a-x
make ROOT=%{buildroot} -C ppp-watch install

# create log files dir
install -d %{buildroot}%{_localstatedir}/log/ppp

# install pam config
install -d %{buildroot}%{_sysconfdir}/pam.d
install -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/pam.d/ppp

# install logrotate script
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -m 644 -p %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/ppp

# install tmpfiles drop-in
install -d %{buildroot}%{_tmpfilesdir}
install -m 644 -p %{SOURCE3} %{buildroot}%{_tmpfilesdir}/ppp.conf

# install scripts (previously owned by initscripts package)
install -d %{buildroot}%{_sysconfdir}/ppp
install -p %{SOURCE4} %{buildroot}%{_sysconfdir}/ppp/ip-down
install -p %{SOURCE5} %{buildroot}%{_sysconfdir}/ppp/ip-down.ipv6to4
install -p %{SOURCE6} %{buildroot}%{_sysconfdir}/ppp/ip-up
install -p %{SOURCE7} %{buildroot}%{_sysconfdir}/ppp/ip-up.ipv6to4
install -p %{SOURCE8} %{buildroot}%{_sysconfdir}/ppp/ipv6-down
install -p %{SOURCE9} %{buildroot}%{_sysconfdir}/ppp/ipv6-up

install -d %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/
install -p %{SOURCE10} %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifup-ppp
install -p %{SOURCE11} %{buildroot}%{_sysconfdir}/sysconfig/network-scripts/ifdown-ppp

# ghosts
mkdir -p %{buildroot}%{_rundir}/ppp

%pre
/usr/bin/getent group dip >/dev/null 2>&1 || /usr/sbin/groupadd -r -g 40 dip >/dev/null 2>&1 || :

%post
%tmpfiles_create ppp.conf

%files
%{_sbindir}/chat
%{_sbindir}/pppd
%{_sbindir}/pppdump
%{_sbindir}/pppoe-discovery
%{_sbindir}/pppstats
%{_sbindir}/ppp-watch
%dir %{_sysconfdir}/ppp
%{_sysconfdir}/ppp/ip-up
%{_sysconfdir}/ppp/ip-down
%{_sysconfdir}/ppp/ip-up.ipv6to4
%{_sysconfdir}/ppp/ip-down.ipv6to4
%{_sysconfdir}/ppp/ipv6-up
%{_sysconfdir}/ppp/ipv6-down
%{_mandir}/man8/chat.8*
%{_mandir}/man8/pppd.8*
%{_mandir}/man8/pppdump.8*
%{_mandir}/man8/pppd-radattr.8*
%{_mandir}/man8/pppd-radius.8*
%{_mandir}/man8/pppstats.8*
%{_mandir}/man8/pppoe-discovery.8*
%{_mandir}/man8/ppp-watch.8*
%{_libdir}/pppd
%ghost %dir %{_rundir}/ppp
%dir %{_sysconfdir}/logrotate.d
%attr(700, root, root) %dir %{_localstatedir}/log/ppp
%config(noreplace) %{_sysconfdir}/ppp/eaptls-client
%config(noreplace) %{_sysconfdir}/ppp/eaptls-server
%config(noreplace) %{_sysconfdir}/ppp/chap-secrets
%config(noreplace) %{_sysconfdir}/ppp/options
%config(noreplace) %{_sysconfdir}/ppp/pap-secrets
%config(noreplace) %{_sysconfdir}/pam.d/ppp
%config(noreplace) %{_sysconfdir}/logrotate.d/ppp
%{_tmpfilesdir}/ppp.conf

%files -n network-scripts-%{name}
%{_sysconfdir}/sysconfig/network-scripts/ifdown-ppp
%{_sysconfdir}/sysconfig/network-scripts/ifup-ppp

%files devel
%{_includedir}/pppd
%doc PLUGINS

%files doc
%doc FAQ README README.cbcp README.linux README.MPPE README.MSCHAP80 README.MSCHAP81 README.pwfd README.pppoe scripts sample README.eap-tls

%changelog
* Fri Jul 15 2022 happy_orange <songnannan@linux.alibaba.com> - 2.4.9-1
- Init pacakge from upstream
